/**
* Classe Constante, representant une Constante (entiere)
*
* @version 0.1, 06/05/2003
* @see Expr
* @see java.lang.String
* @see Type
* @see Valeur
*/
public class Constante extends Expr
{
	private int i;

	/**
	* Constructeur de la classe Constante.
	*
	* @param L'entier a assigner a cette Constante.
	*/
	public Constante (int i)
	{
		this.i = i;
	}

	/**
	* Retourne une String contenant l'entier.
	*
	* @return La String
	*/
	public String expr_str ()
	{
		return (Integer.toString (i));
	}

	/**
	* Retourne le Type TEntier
	*
	* @param L'environnement
	* @return Une nouvelle instance de TEntier.
	*/
	public Type typer (Env envp)
	{
		return (new TEntier());
	}

	/**
	* Retourne la Valeur de la Constante.
	*	
	* @param L'environnement
	* @return Une nouvelle instance de VEntier, contenant la valeur.
	*/
	public Valeur evaluer (Env envp)
	{
		return (new VEntier (i));
	}
}
