/**
* Classe Declaration: Sert a la declaration d'une variable a une expression
* dans une Session..
*
* @version 0.2, 07/05/2003
* @see Expr
* @see Session
* @see java.lang.String
*/
public class Declaration implements java.io.Serializable
{
	private Expr my_expr;
	private String my_name;

	/**
	* Constructeur de la classe Declaration
	*
	* @param String my_name, le nom de la variable
	* @param Expr my_expr, l'expression a affecter.
	*/
	public Declaration (String my_name, Expr my_expr)
	{
		this.my_name = my_name;
		this.my_expr = my_expr;
	}

	/**
	* Methode pour acceder a l'expression de la Declaration
	*
	* @return L'expression.
	*/
	public Expr getExpr ()
	{
		return (this.my_expr);
	}

	/**
	* Methode pour acceder au nom de la variable 
	*
	* @return La String contenant le nom de la variable.
	*/
	public String getString ()
	{
		return (this.my_name);
	}

	/**
	* Execution d'une declaration dans un environnement donn
	*
	* @param env L'environnement
	*/
	public void executer (Env env)
	{
		StringBuffer sb = new StringBuffer ("");
		try {
			sb.append("# let " + this.getString() + " = ");
			sb.append(this.getExpr().expr_str());
			sb.append(" ;; \n");

			sb.append("val " + this.getString() + " : ");
			sb.append(this.getExpr().typer(env).type_str());
			sb.append(" = " + this.getExpr().evaluer(env).val_str());

			/* On n'ajoute pas tout de suite la variable  l'enviro.
			   pour la bonne raison que pour une fermeture, il prend
			   la fonction comme dj existante */

			env.ajt_env (this.getString(), this.getExpr().typer(env),
			             this.getExpr().evaluer (env));

			System.out.println (sb.toString ());
		} catch (Exception ee) {
			System.out.println (sb.toString ());
			System.out.println (ee);
		} finally {
		}
	}
}
