/**
* Classe representant un Et. 
*
* @version 0.1, 06/05/2003
* @see Expr
* @see java.lang.String
* @see TBool
* @see VBool
* @see Env
*/
public class Et extends Expr
{
	private Expr e1;
	private Expr e2;
	
	/**
	* Constructeur de la classe Et 
	*
	* @param Les deux expressions a droite et a gauche de Et.
	*/
	public Et (Expr e1, Expr e2)
	{
		this.e1 = e1;
		this.e2 = e2;
	}

	/**
	* Renvoit la String representant Et. 
	*
	* @return Une String representant Et.
	*/
	public String expr_str ()
	{
		return ("(" + e1.expr_str () + " && " + e2.expr_str () + ")");
	}

	/**
	* Calcule le type Type issu de Et.
	*
	* @param L'environnement. 
	* @return Le Type de ce Et.
	* @exception TypeException
	*            Erreur de typage.
	*/
	public Type typer (Env envp) throws Exception
	{
		if (TBool.isTBool((e1.typer (envp))) == false) {
			throw new TypeException("Et: Erreur de typage: " + e1.expr_str () + " n'est pas booleene.");
		}

		if (TBool.isTBool((e2.typer(envp))) == false) {
			throw new TypeException("Et: Erreur de typage: " + e2.expr_str () + " n'est pas booleene.");
		}

		return (new TBool ());
	}

	/**
	* Calcule la Valeur issue de Et.
	*
	* @param L'environnement
	* @return La Valeur de cette Et.
	* @exception TypeException
	*            Erreur de typage.
	*/
	public Valeur evaluer (Env envp) throws Exception
	{
		if (TBool.isTBool((e1.typer (envp))) == false) {
			throw new TypeException("Et: Erreur de typage: " + e1.expr_str () + " n'est pas booleene.");
		}

		if (TBool.isTBool((e2.typer(envp))) == false) {
			throw new TypeException("Et: Erreur de typage: " + e2.expr_str () + " n'est pas booleene.");
		}

		return (new VBool(e1.evaluer(envp).valeur_bool() 
			&& e2.evaluer(envp).valeur_bool()));
	}
}
