/**
* Classe Faux, representant l'expression Faux (bool false).
*
* @version 0.1, 06/05/2003
* @see Vrai 
* @see Expr
* @see TBool
* @see VBool
* @see Env
*/
public class Faux extends Expr
{
	/**
	* Retourne une String contenant "false"
	*
	* @return "false"
	*/
	String expr_str ()
	{
		return ("false");
	}

	/**
	* Retourne le Type TBool
	*
	* @param Un envirronement.
	* @return Une nouvelle instance de TBool.
	*/
	Type typer (Env envp)
	{
		return (new TBool());
	}

	/**
	* Retourne la Valeur false.
	*
	* @param Un envirronement.
	* @return Une nouvelle instance de VBool(false).
	*/
	Valeur evaluer (Env envp)
	{
		return (new VBool(false));
	}
}
