/**
* Classe Non, representant l'oppose d'un booleen.
*
* @version 0.1, 06/05/2003
* @see Expr
* @see java.lang.String
* @see Type
* @see Valeur
* @see TBool
*/
public class Non extends Expr
{
	private Expr e1;

	/**
	* Constructeur de la classe non
	*
	* @param L'expression.
	*/
	public Non (Expr e1)
	{
		this.e1 = e1;
	}

	/**
	* Retourne une String contenant l'expression de Non.
	*
	* @return La String.
	*/
	public String expr_str ()
	{
		return ("(not " + e1.expr_str () + ")");
	}

	/**
	* Retourne le Type TBool, si l'expresion est de Type TBool
	*
	* @param L'environnement.
	* @return Nouvelle instance de TBool()
	* @exception TypeException 
	*            Erreur de typage
	*/ 
	public Type typer (Env envp) throws Exception
	{
		if (TBool.isTBool(e1.typer(envp)) == false) {
			throw new TypeException("Non: Erreur de typage: " + e1.expr_str () + " n'est pas booleene.");
		}

		return (new TBool ());
	}

	/**
	* Retourne la Valeur de l'expression de Non.
	*
	* @param L'environnement.
	* @return Nouvelle instance de VBool comprennant la valeur
	* @exception TypeException
	*            Erreur de typage. 
	*/
	public Valeur evaluer (Env envp) throws Exception
	{
		if (TBool.isTBool((e1.typer (envp))) == false) {
			throw new TypeException("Non: Erreur de typage: " + e1.expr_str () + " n'est pas booleene.");
		}

		if (e1.evaluer(envp).valeur_bool())
			return (new VBool(false));
		else
			return (new VBool(true));
	}
}
