/**
* La classe representant un couple Valeur/Type, pour etre rattache a un
* envirronement Env.
*
* @version 0.1, 06/05/2003
* @see Env
* @see Valeur
* @see Type
* @see java.lang.Object
* @see java.io.Serializable
*/
public class ObjValTyp implements java.io.Serializable
{
	private Valeur x;
	private Type t;

	/**
	* Constructeur ObjValTyp, prenant une Valeur et un Type
	*
	* @param Valeur x, l'objet Valeur de cette classe.
	* @param Type y, l'object Type de cette classe. 
	*/
	public ObjValTyp (Valeur x, Type t)
	{
		this.x = x;
		this.t = t;
	}

	/**
	* Constructeur ObjValTyp, prenant une Valeur
	*
	* @param Valeur x, l'object Valeur de cette classe.
	*/
	public ObjValTyp (Valeur x)
	{
		this.x = x;
		this.t = null;
	}

	/**
	* Constructeur ObjValTyp, prenant un Type
	*
	* @param Type t, l'object Type de cette classe.
	*/
	public ObjValTyp (Type t)
	{
		this.x = null;
		this.t = t;
	}

	/**
	* Retourne l'objet de type Valeur de cette instance de ObjValTyp.
	*
	* @return Un objet de type Valeur.
	*/
	public Valeur getValeur ()
	{
		return (x);
	}

	/**
	* Retourne l'objet de type Type de cette instance de ObjValTyp.
	*
	* @return Un objet de type Type.
	*/
	public Type getType ()
	{
		return (t);
	}
}
