/**
* Classe Oppose, representant l'oppose d'un nombre.
*
* @version 0.1, 06/05/2003
* @see Expr
* @see java.lang.String
* @see Type
* @see Valeur
* @see TEntier
*/
public class Oppose extends Expr
{
	private Expr e1;

	/**
	* Constructeur de la classe Oppose 
	*
	* @param L'expression.
	*/
	public Oppose (Expr e1)
	{
		this.e1 = e1;
	}

	/**
	* Retourne une String contenant l'expression d'Oppose
	*
	* @return La String.
	*/
	public String expr_str ()
	{
		return ("(- " + e1.expr_str () + ")");
	}

	/**
	* Retourne le Type TEntier, si l'expression est de Type TEntier
	*
	* @param L'environnement.
	* @return Nouvelle instance de TEntier()
	* @exception TypeException
	*            Erreur de typage.
	*/
	public Type typer (Env envp) throws Exception
	{
		if (!TEntier.isTEntier((e1.typer (envp)))) {
			throw new TypeException("Oppose: Erreur de typage: " + e1.expr_str () + " n'est pas entier.");
		}

		return (new TEntier ());
	}

	/**
	* Retourne la Valeur de l'expression d'Oppose.
	*
	* @param L'environnement.
	* @return Nouvelle instance de VEntier comprennant la valeur
	* @exception TypeException
	*            Erreur de typage.
	*/
	public Valeur evaluer (Env envp) throws Exception
	{
		if (TEntier.isTEntier((e1.typer (envp))) == false) {
			throw new TypeException("Oppose: Erreur de typage: " + e1.expr_str () + " n'est pas entier.");
		}

		return (new VEntier(-1 * e1.evaluer(envp).valeur_int()));
	}
}
