/**
* Classe Ou, sur les TBool
*
* @version 0.1, 06/05/2003
* @see Expr
* @see java.lang.String
* @see Type
* @see Valeur
* @see TEntier
*/
public class Ou extends Expr
{
	private Expr e1;
	private Expr e2;

	/**
	* Constructeur de la classe Ou
	*
	* @param Les deux expressions, de droite et de gauche.
	*/
	public Ou (Expr e1, Expr e2)
	{
		this.e1 = e1;
		this.e2 = e2;
	}

	/**
	* Retourne une String contenant l'expression de Non.
	*
	* @return La String
	*/
	public String expr_str ()
	{
		return ("(" + e1.expr_str () + " or " + e2.expr_str () + ")");
	}

	/**
	* Retourne le Type TBool, si l'expression est de Type TBool
	*
	* @param L'environnement
	* @return Nouvelle instance de TBool()
	* @exeception TypeException
	*             Erreur de typage.
	*/
	public Type typer (Env envp) throws Exception
	{
		if (TBool.isTBool((e1.typer (envp))) == false) {
			throw new TypeException("Ou: Erreur de typage: " + e1.expr_str () + " n'est pas booleene.");
		}

		if (TBool.isTBool((e2.typer(envp))) == false) {
			throw new TypeException("Ou: Erreur de typage: " + e2.expr_str () + " n'est pas booleene.");
		}

		return (new TBool ());
	}

	/**
	* Retourne la Valeur de l'expression de Non.
	*
	* @param L'environnement.
	* @return Nouvelle instance de VBool comprenant la Valeur
	* @exception TypeException
	*            Erreur de typage.
	*/
	public Valeur evaluer (Env envp) throws Exception
	{
		if (TBool.isTBool((e1.typer (envp))) == false) {
			throw new TypeException("Ou: Erreur de typage: " + e1.expr_str () + " n'est pas booleene.");
		}

		if (TBool.isTBool((e2.typer(envp))) == false) {
			throw new TypeException("Ou: Erreur de typage: " + e2.expr_str () + " n'est pas booleene.");
		}

		return (new VBool(e1.evaluer(envp).valeur_bool() 
			|| e2.evaluer(envp).valeur_bool()));
	}
}
