/**
* La classe representant une valeur entiere.
*
* @version 0.1, 06/05/2003
* @see Valeur
* @see ValeurException
* @see java.lang.String 
* @see java.lang.Object
*/
public class VEntier extends Valeur
{
	private int value;

	/**
	* Constructeur de la classe VEntier
	*
	* @param Un entier pour initialiser la valeur de la classe VEntier.
	*/
	public VEntier (int v)
	{
		this.value = v;
	}

	/**
	* Retourne un objet String representant la valeur contenue dans la classe.
	*
	* @return Un objet String contenant la valeur entiere contenue.
	*/	
	public String val_str ()
	{
		return (Integer.toString (value));
	}

	/**
	* Eleve une exception de type ValeurException, car un entier n'a pas de
	* valeur booleen.
	*
	* @return Rien.
	* @exception ValeurException
	*            Un entier n'a pas de valeur entiere.
	*/
	public boolean valeur_bool () throws ValeurException
	{
		throw new ValeurException ("Un entier n'a pas de valeur booleene.\n");
	}

	/**
	* Retourne la valeur entiere contenue dans la classe.
	*
	* @return La valeur entiere contenue dns la classe.
	*/
	public int valeur_int () throws ValeurException
	{
		return (value);
	}
}
