/**
* Le type de classe abstraite representant une valeur.
*
* @version 0.1, 06/05/2003
* @see java.io.Serializable
* @see java.lang.String 
* @see java.lang.Object
* @see ValeurException
* @see VBool
* @see VEntier
* @see VFermeture
*/
public abstract class Valeur implements java.io.Serializable
{
	/**
	* Renvoit un objet String contenant une expression lisible de la valeur. 
	*/
	abstract String val_str ();

	/**
	* Renvoit un booleen, si il s'agit d'une valeur booleene.
	* Cette fonction peut lever une exception si il n'est pas applique sur une
	* classe qui n'est pas une instance de VBool.
	*
	* @return Un booleen, soit true ou false.
	*/
	abstract boolean valeur_bool () throws ValeurException;

	/**
	* Renvoit un entier, representatif de la valeur de la classe de type Valeur,
	* si cette methode est appliquee sur un objet qui est une instance de
	* TEntier. Sinon, leve une exception.
	*
	* @return Un entier.
	*/
	abstract int valeur_int () throws ValeurException;

	/**
	* Affiche une representation lisible de la valeur.
	*/
	public void afficher_val ()
	{
		System.out.println(this);
	}

	/**
	* Methode par defaut pour la representaton de la valeur.
	*/
	public String toString ()
	{
		return (this.val_str ());
	}
}
