/**
* La classe representant une Variable.
* Elle est compose d'un nom de variable, qui est un objet String.
* 
* @version 0.1, 06/05/2003
* @see java.lang.String
* @see Expr
* @see Env
* @see Exception
* @see Type
* @see Valeur
*/
public class Variable extends Expr
{
	private String s;

	/**
	* Constructeur de Variable
	*
	* @param String s, le nom de cette Variable.
	*/
	public Variable (String s)
	{
		this.s = s;
	}

	/**
	* Renvoit la chaine lisible de la Variable.
	*
	* @return La chaine.
	*/
	public String expr_str ()
	{
		return (s);
	}

	/**
	* Renvoit le Type de la Variable dans l'environement donne
	*
	* @param Env envp: L'environnement
	* @return Le type de la Variable.
	*/
	public Type typer (Env envp) throws Exception
	{
		return (envp.typ_de (s)); 
	}
	
	/**
	* Renvoit la Valeur de la Variable dans l'environement donne
	*
	* @param Env envp: L'environnement
	* @return La Valeur de la Variable
	*/
	Valeur evaluer (Env envp) throws Exception
	{
		return (envp.val_de (s));
	}
}
