/**
* Classe Vrai, representant l'expression Vrai (bool true).
*
* @version 0.1, 06/05/2003
* @see Faux
* @see Expr
* @see TBool
* @see VBool
* @see Env
*/
public class Vrai extends Expr
{
	/**
	* Retourne une String contenant "true"
	*
	* @return "true"
	*/
	String expr_str ()
	{
		return ("true");
	}

	/**
	* Retourne le Type TBool
	*
	* @param Un envirronement.
	* @return Une nouvelle instance de TBool.
	*/
	Type typer (Env envp)
	{
		return (new TBool());
	}

	/**
	* Retourne la Valeur true.
	*
	* @param Un envirronement.
	* @return Une nouvelle instance de VBool(true).
	*/
	Valeur evaluer (Env envp)
	{
		return (new VBool(true));
	}
}
