/** Represente l'environnement: Liste de Variable * Type * Valeur
 *
 */

import java.util.*;

class EnvValElt implements java.io.Serializable
{
	private String v;
	private Valeur x;

	/* Utilisee juste pour faire une comparaison de caractere */
	public EnvValElt (String v)
	{
		this.v = v;
	}

	public EnvValElt (String v, Valeur x)
	{	
		this.v = v;
		this.x = x;
	}

	public Valeur getValeur ()
	{
		return (this.x);
	}

	public String getString ()
	{
		return (this.v);
	}	

	public boolean equals (Object obj)
	{
		if (v.compareTo(((EnvValElt)obj).getString ()) == 0) 
			return (true);
		else
			return (false);
	}
}

class EnvTypElt implements java.io.Serializable
{
	String v;
	Type t;

	public EnvTypElt (String v)
	{
		/* Oui, c'est moche, mais c'est juste utilise pour faire une comparaison de caractere */
		this.v = v;
	}

	public EnvTypElt (String v, Type t)
	{
		this.v = v;
		this.t = t;
	}

	public Type getType ()
	{
		return (this.t);
	}

	public String getString ()
	{
		return (this.v);
	}

	public boolean equals (Object obj)
	{
		if (v.compareTo(((EnvTypElt)obj).getString ()) == 0) 
			return (true);
		else
			return (false);
	}
}


class Env implements java.io.Serializable
{
	public ArrayList env_val_list; /* Liste de EnvValElt */
	public ArrayList env_typ_list; /* Liste de EnvTypElt */

	public Env ()
	{
		env_val_list = new ArrayList ();
		env_typ_list = new ArrayList ();
	}

	public Env (ArrayList a, ArrayList b) /* Utilisee pour une copie */
	{
		env_val_list = a;
		env_typ_list = b;
	}

	public ArrayList get_val_list_copy ()
	{
		return ((ArrayList)env_val_list.clone());
	}

	public ArrayList get_typ_list_copy ()
	{
		return ((ArrayList)env_typ_list.clone());	
	}

	/* Pour faire une copie d'un environnement */
	public static Env CopieEnv (Env old)
	{
		return (new Env (old.get_val_list_copy(), old.get_typ_list_copy()));
	}

	public void ajt_env (String s, Type t, Valeur v)
	{
		this.ajt_env_val (s, v);
		this.ajt_env_typ (s, t);

		return ;
	}

	public void ajt_env_val (String s, Valeur v)
	{
		int idx;

/* XXX: Cf comment ajt_env_typ */
		/* Si il existe deja, on le retire (au cas ou ...) */
/*
		if ((idx = env_val_list.indexOf (new EnvValElt(s))) != -1) {
			env_val_list.remove (idx);
		}
*/

		/* On le rajoute */
		env_val_list.add (new EnvValElt (s, v));

		return ;
	}

	public void del_env_val (String s)
	{
		int idx;
		if ((idx = env_val_list.lastIndexOf (new EnvValElt(s))) != -1) {
			env_val_list.remove (idx);
		}
		return ;
	}

	public void ajt_env_typ (String s, Type t)
	{
		int idx;

/* XXX: Pour tests: Si on cree un nouvel env. avec des noms de var deja
        existantes, ca les rajoute en debut de liste sans re-ecrire les
        autres */

		/* Si il existe deja, on le retire (au cas ou ...) */
/*
		if ((idx = env_typ_list.indexOf (new EnvTypElt(s))) != -1) {
			env_typ_list.remove (idx);
		}
*/
		/* On le rajoute */
		env_typ_list.add (new EnvTypElt (s, t));

		return ;
	}

	public void del_env_typ (String s)
	{
		int idx;
		if ((idx = env_typ_list.lastIndexOf(new EnvTypElt(s))) != -1) {
			env_typ_list.remove (idx);
		}
		return ;
	}

	public Valeur val_de (String s) throws EnvException
	{
		int idx;
		EnvValElt tmp;
		if ((idx = env_val_list.lastIndexOf (new EnvValElt(s))) == -1) {
			throw new EnvException ("Variable \"" + s + "\" non definie.");
		}

		tmp = (EnvValElt) env_val_list.get (idx);

		return (tmp.getValeur ());
	}

	public Type typ_de (String s) throws EnvException
	{
		int idx;
		EnvTypElt tmp;

		if ((idx = env_typ_list.lastIndexOf (new EnvTypElt(s))) == -1) {
			throw new EnvException ("Le type de \"" + s + "\" est non defini.");
		}

		tmp = (EnvTypElt) env_typ_list.get (idx);

		return (tmp.getType ());
	}

	public boolean dans_env (String s) throws EnvException
	{
		if (env_val_list.indexOf (new EnvValElt(s)) != -1)
			return true;
		else
			return false;
	}

	public String env_str (int mode)
	{
		// Utilisation d'un StringBuffer
		StringBuffer sb = new StringBuffer ("");
		int l, i;

		Object tab[] = env_val_list.toArray(); 
		l = env_val_list.size ();

		for (i = 0; i < l; i ++) {
			if (mode == 1) {
				// pour la VFermeture 
				if (i != 0) sb.append (";");
				sb.append ("(" + ((EnvValElt)tab[i]).getString() + "," + ((EnvValElt)tab[i]).getValeur() + ")");
			} else {
				// pour le LetIn
				if (i != 0) sb.append (" and ");
				sb.append ("(" + ((EnvValElt)tab[i]).getString() + "=" + ((EnvValElt)tab[i]).getValeur() + ")");
			}
		}
	
		return (sb.toString());
	}
}
