import java.io.*;

/**
* Classe Session, definissant les actions possibles (declaration, execution)
* lors d'une session caml.
*
* @version 0.1, 06/05/2003
* @see java.io.Serializable
* @see Declaration
* @see java.lang.String
* @see java.lang.StringBuffer
* @see TypeException
* @see ValeurException
* @see EnvException
* @see Exception
* @see Expr
* @see Env
*/
public class Session implements java.io.Serializable
{
	private Env my_envp;	

	/**
	* Constructeur Session.
	*/
	public Session ()
	{
		my_envp = new Env ();
	}

	/**
	* Execution d'une Declaration. 
	*
	* @param: Declaration a, la Declaration a executer.
	*/
	public void executer (Declaration a)
	{
		StringBuffer sb = new StringBuffer ("");
		try {
			sb.append("let " + a.getString() + "=");
			sb.append(a.getExpr().expr_str());
			sb.append("\n");

			my_envp.ajt_env (a.getString(), a.getExpr().typer(my_envp), 
			                 a.getExpr().evaluer (my_envp));

			sb.append("val " + a.getString() + " : ");
			sb.append(a.getExpr().typer(my_envp).type_str());
			sb.append("\n");
		} catch (TypeException te) {
		} catch (ValeurException te) {
		} catch (EnvException te) {
		} catch (Exception ee) {
			System.out.println (" !!! " + ee + " !!!");
		} finally {
			System.out.println (sb.toString ());
			System.out.println ("- fin");
		}

		return ;
	}

	/**
	* Execution d'une expression
	*
	* @param: Expr e, l'expression a executer.
	*/
	public void executer (Expr e)
	{
		StringBuffer sb = new StringBuffer ("");
		try {
			sb.append(e.expr_str());
			sb.append("\n");
			sb.append(e.typer(my_envp).type_str());
			sb.append(" = ");
			sb.append(e.evaluer(my_envp).val_str());
			sb.append("\n");
		} catch (TypeException te) {
		} catch (ValeurException te) {
		} catch (EnvException te) {
		} catch (Exception ee) {
			System.out.println (" !!! " + ee + " !!!");
		} finally {
			System.out.println (sb.toString ());
			System.out.println ("- fin");
		}
		return ;
	}

	/**
	* Afficher l'envirronement de la Session.
	*/
	public void debug_voir_env ()
	{
		System.out.println (my_envp.env_str(1));
	}

	/**
	* Lire un nom de fichier, et le renvoyer
	*
	* @return Une String contenant le nom du fichier.
	*/
	public static String file_name ()
	{
		String l;
		BufferedReader myInput;
		myInput = new BufferedReader(new InputStreamReader(System.in));


		while (true) {
			try {
				System.out.println("Merci de donner le nom de fichier:");
				l = myInput.readLine ();
				return (l);
			} catch (IOException ioe) {
				System.out.println ("mauvaise saisie !");
			}
		}
	}

	/* XXX: Faire un test sur le bon deroulement de cette procedure */

	/**
	* Sauver la session: Saisit le nom de fichier, et le sauver
	*/
	public void sauve_session ()
	{
		FileOutputStream ostream;
		ObjectOutputStream p;

		try {
			ostream = new FileOutputStream ("/tmp/" + file_name());
			p = new ObjectOutputStream (ostream);

			p.writeObject (this);
			p.flush ();
			ostream.close ();
		} catch (Exception esave) {
			System.out.println ("paf casse: " + esave);
		}

		return ;
	}

	/**
	* Charger une session: Saisit du nom de fichier, et le charger.
	*/
	public static Session charge_session ()
	{
		FileInputStream istream;
		ObjectInputStream q;
		Session test;

		try {
			istream = new FileInputStream ("/tmp/"+file_name());
			q = new ObjectInputStream (istream);

			test = (Session)q.readObject();
			istream.close();
			return test;
		} catch (Exception eload) {
			System.out.println ("paf casse: " + eload);
		}

		return null;
	}
}
