/**
* Classe de test, main.
*
* @version 0.2, 07/05/2003
* @see java.lang.Object
* @see java.lang.String
* @see Env
* @see Session
* @see Expr
* @see Exception 
*/
public class main 
{
	public static void main (String [] argv)
	{
		/* Nous avons un environnement */
		Env mon_env;
		/* Nous utilisons un mini env pour le let In ... */
		Env mini_env;

		Expr ex_a, ex_b, ex_c, ex_d;

		/* On commence avec des sessions */
		Session ses;

		/* On cree notre session */
		ses = new Session ();

		ses.ajouter_ins (new Declaration ("a", new Vrai())); /* let a = true ;; */
		ses.ajouter_ins (new Declaration ("b", new Faux())); /* let b = false ;; */

		ses.ajouter_ins (new Egal(new Variable("a"), new Variable("b"))); /* a = b ;; */

		/* On execute notre session, en utilisant le 2nd constructeur:
		   Celui ci renvoit un nouvel env. contenant modifie par ce que l'on a fait. */

/* Resultat de l'execution: 
# let a = true ;; 
val a : bool = true
# let b = false ;; 
val b : bool = false
# (a = b) ;;
bool = false
*/
		/* if a then 1 else 2 ;; */
		ses.ajouter_ins (new If(new Variable ("a"), new Constante (1), new Constante (2)));
		/* if b then 1 else 2 ;; */
		ses.ajouter_ins (new If(new Variable ("b"), new Constante (1), new Constante (2)));

/* Resultat de l'execution:
# (if a then 1 else 2) ;;
int = 1
# (if b then 1 else 2) ;;
int = 2
*/

		/* let a = 10 ;; */
		ses.ajouter_ins(new Declaration ("a", new Constante (10)));

		/* let x = 6 ;; */
		ses.ajouter_ins(new Declaration ("x", new Constante (6)));

		/* let u = fun x -> x + a ;; */
		ses.ajouter_ins(new Declaration ("u", new Fonction ("x", new TEntier(), new Addition (new Variable ("x"), new Variable ("a")))));

		/* let x = 7 ;; */
		ses.ajouter_ins(new Declaration ("x", new Constante (7)));

		mon_env = ses.executer();

		/* u ;; */
		ses.ajouter_ins(new Variable ("u"));

		/* u 4 ;; */
		ses.ajouter_ins(new Application (new Variable("u"), new Constante (4)));
		/* u a ;; */
		ses.ajouter_ins(new Application (new Variable("u"), new Variable ("a")));

/* Resultat de l'execution:
# let a = 10 ;; 
val a : int = 10
# let x = 6 ;; 
val x : int = 6
# let u = (fun x -> (x + a)) ;; 
val u : (int) -> int = < x ~> (x + a) , [(b,false);(a,10)] >
# let x = 7 ;; 
val x : int = 7
# u ;;
(int) -> int = < x ~> (x + a) , [(b,false);(a,10)] >
# (u 4) ;;
int = 14
# (u a) ;;
int = 20

Env a la fin:
(x=7);(b=false);(a=10);(u=< x ~> (x + a) , [(b,false);(a,10)] >)
*/

/*
		ses.sauve_session ();

		ses = Session.charge_session ();
		mon_env = ses1.executer (mon_env);
		System.out.println(mon_env.env_str(2));
*/

		/* Utilisation de LetIn: */
		mini_env = new Env();
		ex_a = new Constante (1);
		ex_b = new Variable ("u"); 
		ex_c = new Variable ("x");

		mini_env.ajt("a", ex_a, mon_env);
		mini_env.ajt("b", ex_b, mon_env); 
		mini_env.ajt("c", ex_c, mon_env);

		/* let a = 1 and b = u and c = x in u ;;*/
		ses.ajouter_ins(new LetIn (mini_env, new Variable ("u")));

		/* let a = 1 and b = u and c = x in b a ;;*/
		ses.ajouter_ins(new LetIn (mini_env, new Application (new Variable("b"), new Variable ("a"))));

		ex_d = new Variable ("b");
		mini_env.ajt ("d", ex_d, mon_env);
		/* let a = 1 and b = u and c = x and d = b in d ;; */
		ses.ajouter_ins(new LetIn (mini_env, new Variable ("d")));

		mini_env = new Env();
		/* let a = 1 + 2 */
		ex_a = new Addition (new Constante(1), new Constante(2));
		/* let b = true or false */
		ex_b = new Ou (new Vrai(), new Faux());
		/* fun x -> x + a*/
		ex_c = new Fonction ("x", new TEntier(), new Addition (new Variable ("x"), new Variable ("a")));

		mini_env.ajt("a", ex_a, mon_env); 
		mini_env.ajt("b", ex_b, mon_env); 
		mini_env.ajt("c", ex_c, mon_env);

		/* let a = 1 + 2 and b = true or false and c = fun x -> x + a in if b then c a else - a ;; */

		ses.ajouter_ins(new LetIn(mini_env, new If(new Variable("b"), new Application(new Variable("c"), new Variable("a")), new Oppose(new Variable("a"))))); 

		mon_env = ses.executer(mon_env);

/* Resultat de l'execution:

# (let (b=< x ~> (x + a) , [(b,false);(a,10);(u,< x ~> (x + a) , [(b,false);(a,10)] >)] >) and (a=1) and (c=7) in u) ;;
(int) -> int = < x ~> (x + a) , [(b,false);(a,10);(u,< x ~> (x + a) , [(b,false);(a,10);(u,< x ~> (x + a) , [(b,false);(a,10)] >)] >)] >

// Correspond a let b = u and a = 1 in b a ;;

# (let (b=< x ~> (x + a) , [(b,false);(a,10);(u,< x ~> (x + a) , [(b,false);(a,10)] >)] >) and (a=1) and (c=7) in (b a)) ;;
int = 11

// Correspond a let b = u and d = b in b ;;
# (let (b=< x ~> (x + a) , [(b,false);(a,10);(u,< x ~> (x + a) , [(b,false);(a,10)] >)] >) and (a=1) and (d=false) and (c=7) in d) ;;
bool = false

*/

/*
		} catch (Exception exep) {
			System.out.println (exep);
		}*/
	}
}
